-- #106
CREATE TABLE shorturlredirection (
     shorturlredirectionid integer  not null AUTO_INCREMENT
,    siteid               integer  not null
,    languageid           integer  not null
,    contentobjectid      integer  not null
,    uri                  varchar(255) CHARACTER SET ascii COLLATE ascii_general_ci not null 

,   constraint pk_shorturlredirection           primary key (shorturlredirectionid)
,   constraint fk_shorturlredirection_siteid    foreign key (siteid)
        references site                             (siteid)
,   constraint fk_shorturlredirection_languageid foreign key (languageid)
        references language                         (languageid)
,   constraint fk_shorturlredirection_contentobjectid foreign key (contentobjectid)
        references contentobject                    (contentobjectid)
)
GO
CREATE UNIQUE INDEX u_shorturlredirection_site_uri ON shorturlredirection (siteid, uri)
GO

CREATE INDEX i_shorturlredirection_object_language ON shorturlredirection (contentobjectid, languageid)
GO

CREATE INDEX i_shorturlredirection_languageid ON shorturlredirection (languageid)
GO
