#BLOCK("NewLineReplace", "")
var require = {
		baseUrl: "#System.StoreRoot[js]/lib",

		paths: {
		#IF(#Shop.FeatureMaxValue.GallerySize)
			"yourfiles": "#Shop.MediaGallery.WebPath[js]"
		#ENDIF
		},

		shim: {
	        "backbone": {
	            deps: ["underscore", "jquery"],
	            exports: "Backbone"
	        },

	        "underscore": {
	            exports: "_"
	        },
	        "fabric": {
		        exports: "fabric"
	        },
	        "ckeditor/ckeditor": {
	        	init: function () {
	        		/* Try to inherit config from parent frame (MBO) */
	        		try {
		        		top.require(["ckeditor/config"], function () {
							this.CKEDITOR.editorConfig = top.CKEDITOR.editorConfig;
						});
					}
					catch (error) {
					}
				},
				exports: "CKEDITOR"
	        }
	    },

	    config: {
	    	"ep": {
				version: '#System.EpagesVersion',
				webRoot: '#WebRoot[js]',
				storeName: '#StoreName[js]',
				storeWebRoot: '#WebRoot[js]/#StoreName[js]',
				storeRoot: '#System.StoreRoot[js]',
				storeTypeRoot: '#System.StoreRoot[js]',
				javascriptRoot: '#System.StoreRoot[js]/lib',
				siteRoot: '#Site.WebPath[js]',
				siteId: '#Site.ID',
				siteGuid: '#Site.GUID',
				iconsRoot: '#System.StoreRoot[js]/BO/icons',
				maxContentLength: #IF(#WebInterfaceConf.MAXCONTENTLENGTH) #WebInterfaceConf.MAXCONTENTLENGTH #ELSE 5120 #ENDIF,
				debugLevel: #DebugLevel[js],
				languageId: '#INPUT.LanguageID',
				language: '#INPUT.Language'
	    	},

	    	"jquery/i18n": {
		        region: '#INPUT.Locale'.replace(/_/,'-'),
		        currency: [
			    	'#INPUT.CurrencyID',
					#IF(#User.CurrencyID)'#User.CurrencyID',#ENDIF
			    	#IF(#LENGTH(#Site.CurrencyID))'#Site.CurrencyID',#ENDIF
			    	'#INPUT.CurrencyID'
			    ]
		    },

		    "jquery/dict": {
			    region: '#INPUT.Language'
		    },

		    "jquery/metaparse": {
			    type: "data",
			    name: "js",
			    autoparse: true
		    },

		    "util/mime": {
				groups: {
					"image/*": "image/png,image/jpeg,image/jpg,image/gif,image/vnd.microsoft.icon,image/x-icon,image/x-win-bitmap",
					"document/*": "application/pdf,application/msword,application/vnd.ms-excel,application/rtf,application/vnd.openxmlformats-officedocument.wordprocessingml.document,application/vnd.openxmlformats-officedocument.spreadsheetml.sheet",
					"audio/*": "audio/mpeg,audio/x-ms-wma,audio/ogg,audio/flac,audio/x-ms-wma",
					"video/*": "video/x-msvideo,video/mp4,video/mpeg,video/x-ms-wmv,video/x-flv"
				}
		    },

		    "util/storage": {
			    namespace: "#StoreName[0]#Site.ID"+"::"
		    }
	    }
	},

	epConfig = require.config.ep,

	CKEDITOR_BASEPATH = "#System.StoreRoot[js]/lib/ckeditor/",

	CKEDITOR_AMD_REQUIRE = function (depends) {
		for (var i in depends) {
			depends[i] = (depends[i])
				.replace(CKEDITOR.basePath, "ckeditor/")
				.replace(/(\.js(\?.*)?$)/, "");
		}

		return require.apply(require, arguments);
	};

#REM /* use noscript class instead of noscript tags to provide content if scripting is disabled */ #ENDREM
document.documentElement.className += " script";
#REM /* setup jQuery defaults */ #ENDREM
#ENDBLOCK