/*
 * @copyright		© Copyright 2006-2012, epages GmbH, All Rights Reserved.
 *
 * @module			de_epages.externalcontent.ui.googleplus
 *
 * @revision		$Revision: 1.1 $
 */
/*jslint nomen: true*/
/*global define, window*/
define('de_epages/externalcontent/ui/googleplus', [
	'jquery/ui/widget',
	'ep',
	'de_epages'
], function ($, ep, de_epages) {
    'use strict';
    // Constants.
    var gClassNames = 'SocialWeb',
        ajaxCache;

    // The actual widget.
    $.widget('ui.externalcontentUiGoogleplus', {
        options: {
            href: ep.config.canonicalUrl || ep.config.webUrl,
            // URL to which +1 should reference.
            layout: 'standard',
            // String specifying the size of the button.
            // Possible values: 'small', 'medium', 'standard', 'tall'.
            type: 'bubble'
            // String specifying the annotation (counter) shown.
            // Possible values: 'none', 'bubble'.
        },

        _create: function () {
            var self = this,
                o = self.options;
            // Tell google to wait for us to tell *gapi.plusone* to render the button. (See below.)
            window.___gcfg = {
                parsetags: 'explicit',
                lang: ep.config.language
            };
            // Append *container* for gadget to *self.element*.
            self.container = $('<div>').appendTo(self.element.addClass(gClassNames));

            // Load script from Google.
            if (!ajaxCache) {
                if (window.gapi && window.gapi.plusone) {
                    ajaxCache = $.Deferred().resolve();
                } else {
                    ajaxCache = $.ajax({
                        dataType: 'script',
                        url: 'https://apis.google.com/js/plusone.js',
                        cache: true
                    });
                }
            }

            ajaxCache.done(function () {
                // Render button.
                window.gapi.plusone.render(self.container[0], {
                    href: o.href,
                    size: o.layout,
                    annotation: o.type
                });
            });
        },

        destroy: function () {
            // Remove all traces of the widget.
            this.element.removeClass(gClassNames);
            this.container.remove();
            this._superApply(arguments);
        }

    });

    return de_epages;

});