/*
 * @copyright   © Copyright 2006-2011, epages GmbH, All Rights Reserved.
 *
 * @module      de_epages.externalcontent.ui.twitter
 *
 * @revision    $Revision: 1.1 $
 */
/*jslint nomen: true*/
/*global define, document, window*/
define('de_epages/externalcontent/ui/twitter', [
    'jquery/ui/widget',
    'ep',
    'de_epages',
    '$tmpl!./twitter'
], function ($, ep, de_epages, template) {
    'use strict';
    // Constants.
    var gClassNames = 'SocialWeb';

    $.widget('ui.externalcontentUiTwitter', {

        options: {
            url: ep.config.canonicalUrl || ep.config.webUrl,
            type: 'share',
            // Expects one of the following string values: 'share', 'follow'.
            // 'profile' and 'search' have been removed, since they are both no longer supported by twitter.
            username: '',
            // The username for 'via', if type 'share'.
            text: $(document).attr('title'),
            // The default tweet text.
            count: 'none',
            // String specifying the count annotation type. Possible values: 'none', 'vertical', 'horizontal'.
            showcount: false
            // Show counter?
        },

        _create: function () {
            var o = this.options,
                type = o.type;

            // With EPG-28229 we removed the types 'profile' and 'search'
            // but it is possible that merchants still have these types in their shop
            // so we will only render the supported types
            if ((type === 'share') || (type === 'follow')) {
                this._twitterButton();
            }
        },

        _twitterButton: function () {
            var o = this.options,
                pluginName = 'de_epages.externalcontent.ui.twitter';

            // Append button placeholder.
            this.renderedTemplate = template(o).appendTo(this.element.addClass(gClassNames));

            // Load Twitter Button API.
            $.ajax({
                dataType: 'script',
                url: '//platform.twitter.com/widgets.js',
                cache: true,
            }).done(function () {
                // Render button.
                window.twttr.widgets.load();
            });
        },

        destroy: function () {
            // Remove all traces of the widget.
            this.element.removeClass(gClassNames);
            this.renderedTemplate.remove();
            this._superApply(arguments);
        }

    });

    return de_epages;
});