/*
 * @copyright		© Copyright 2006-2010, epages GmbH, All Rights Reserved.
 *
 * @module			ep.dict
 *
 * @revision		$Revision: 1.5.4.1 $
 */

define("ep/dict", [
	"jquery",
	"ep",
	"$dict!ep/dict",

	"jquery/dict",
	"jquery/tmpl"
], function ($, ep, epDict) {

	// Prevent fail of dictionay test case
	// backward compatible -> require module ep/dict expects $dict!ep/dict is also defined
	// epDict.translate('Save')
	$.each( ['translate', 'parse'], function( i, name ){
		$.Dictionary.prototype[ name + 'Data' ] = function( key, data ){
			return $.tmpl( '<span>' + this[ name ](key) + '</span>', [data] )	// replace key marker in translated string with given data
				.html()															// get inner HTML
				.replace(/(^|[^ ])(&nbsp;)([^ ]|$)/g,"$1 $3");					// replace strange &nbsp; to regular space
		};
	});

	// set ep.dict as alias of $.dict
	ep.extend({
		dict: $.dict
	});

	return ep;
});