/*
 * @copyright		© Copyright 2006-2010, epages GmbH, All Rights Reserved.
 *
 * @module			de_epages.order.multiCheckOutProcess
 *
 * @revision		$Revision: 1.1 $
 */

define("de_epages/order/inc/multicheckoutprocess", [
	"jquery",

	"ep/fn/busy",
	"ep/ui/form"
], function ($) {

	var body	= [],
		busy	= function( toggle ){
			( body.length ? body : (body = $('.MultipleStep-Container')) ).busy( toggle );
		};

	return function( selector ){
		var	form = $(selector),
			process = form.data('SFMultiCheckOutProcess'),
			next,
			refresh,
			map;

		if( !process ){
			// create process object
			form.uiForm()
				.data('SFMultiCheckOutProcess', (process = {}) )
				.on('submit', function () {
					busy('show');
				})
				.on('submitFail', function (event) {
					busy('hide');
				});

			next = {
				ViewAction		: form.find('.ViewAction').val(),
				ViewObjectID	: form.find('.ViewObjectID').val(),
				ChangeAction	: form.find('.ChangeAction').val(),
				ChangeObjectID	: form.find('.ChangeObjectID').val(),
				ButtonText		: form.find('.SubmitButton').html()
			};
			refresh = {
				ViewAction		: form.find('.ViewActionCurrent').val()		|| next.ViewAction,
				ViewObjectID	: form.find('.ViewObjectIDCurrent').val()	|| next.ViewObjectID,
				ChangeAction	: form.find('.ChangeActionCurrent').val()	|| next.ChangeAction,
				ChangeObjectID	: form.find('.ChnageObjectIDCurrent').val()	|| next.ChangeObjectID,
				ButtonText		: form.find('.ButtonTextCurrent').val()		|| next.ButtonText
			};
			map = {
				next	: next,
				refresh	: refresh
			};

			// add change set on submit handle
			process.setStep = function( type, alternativeButtonText ){
				form.find('.ViewAction').val( map[ type ].ViewAction );
				form.find('.ViewObjectID').val( map[ type ].ViewObjectID );
				form.find('.ChangeAction').val( map[ type ].ChangeAction );
				form.find('.ChangeObjectID').val( map[ type ].ChangeObjectID );
				form.find('.SubmitButton').html( alternativeButtonText || map[ type ].ButtonText );

				return process;
			};
			process.refresh = function(){
				this.setStep('refresh')
					.submit();
				return process;
			};
			// add form submit handle
			process.submit = function(){
				form.trigger('submit');
				return process;
			};
			// handle status of submit buttons
			process.showButton = function(){
				form.find('.SubmitButton').parent().show();
				return process;
			}
			process.hideButton = function(){
				form.find('.SubmitButton').parent().hide();
				return process;
			}
			process.enableButton = function(){
				form.find('.SubmitButton').attr('disabled',false);
				return process;
			}
			process.disableButton = function(){
				form.find('.SubmitButton').attr('disabled',true);
				return process;
			}
		}

		return process;
	};
});