-- #201
CREATE TABLE customerorder (
     orderid              integer  not null
,    shopid               integer  not null
,    customerid           integer  not null
,    userid               integer  null
,    lineitemcontainerid  integer  null
,    shopaddressid        integer  null
,    billingaddressid     integer  null
,    shippingaddressid    integer  null
,    viewedon             datetime  null
,    cancelledon          datetime  null
,    inprocesson          datetime  null
,    pendingon            datetime  null
,    readyforshippingon   datetime  null
,    partlydispatchedon   datetime  null
,    dispatchedon         datetime  null
,    shippedon            datetime  null
,    partlyinvoicedon     datetime  null
,    invoicedon           datetime  null
,    partlypaidon         datetime  null
,    paidon               datetime  null
,    closedon             datetime  null
,    archivedon           datetime  null
,    returnedon           datetime  null

,   constraint pk_customerorder                 primary key (orderid)
,   constraint fk_customerorder_lineitemcontainerid foreign key (lineitemcontainerid)
        references lineitemcontainer                (lineitemcontainerid)
,   constraint fk_customerorder_customerid      foreign key (customerid)
        references customer                         (customerid)
,   constraint fk_customerorder_shopaddressid   foreign key (shopaddressid)
        references address                          (addressid)
,   constraint fk_customerorder_billingaddressid foreign key (billingaddressid)
        references address                          (addressid)
,   constraint fk_customerorder_shippingaddressid foreign key (shippingaddressid)
        references address                          (addressid)
,   constraint fk_customerorder_shopid          foreign key (shopid)
        references shop                             (shopid)
,   constraint fk_customerorder_userid          foreign key (userid)
        references users                            (userid)
,   constraint fk_customerorder_orderid         foreign key (orderid)
        references object                           (objectid)
)
GO
CREATE INDEX i_order_customer ON customerorder (customerid)
GO

CREATE INDEX i_order_shop ON customerorder (shopid)
GO

CREATE INDEX i_order_user ON customerorder (userid)
GO

CREATE INDEX i_customerorder_lineitemcontainerid ON customerorder (lineitemcontainerid)
GO

CREATE INDEX i_customerorder_shopaddressid ON customerorder (shopaddressid)
GO

CREATE INDEX i_customerorder_billingaddressid ON customerorder (billingaddressid)
GO

CREATE INDEX i_customerorder_shippingaddressid ON customerorder (shippingaddressid)
GO
