define(['testsuite/qunit', 'jquery', 'de_epages/presentation/ui/stateselection', '$ready!'], function (QUnit, $, de_epages) {

	QUnit.module('de_epages/presentation/ui/stateselection');

	QUnit.asyncTest('de_epages/presentation/ui/stateselection', function () {

		// Check prototype methods.
		$.each(['_create', '_setOption', 'destroy', '_onCountrySelect', '_render'], function (i, fn) {
		
			QUnit.equal(
				$.isFunction($.ui.presentationUiStateselection.prototype[fn]),
				true,
				'$.isFunction(' + fn + '):'
			);
		
		});

		// Our test *form*.
		var $form = $('form#test');

		// Init two *uiStateselection* widgets.
		// (Like during checkout...)
		$('#' + 'ID509CF322AC1432E110B9_StateDiv').presentationUiStateselection({
			"input":{
				"name":"State1",
				"id":"ID509CF322AC1432E110B9_State",
				"mandatoryStar":"*",
				"label":"County",
				"emptyEntry":"(Select entry)"
			},
			"countrySelectId" : "ID509CF322AC1432E110B9_CountryID",
			"cssClasses":{
				"dialogError" : "DialogError",
				"inputField" : "InputField",
				"inputLabelling" : "InputLabelling",
				"input" : "Text",
				"select" : "LongText"
			},
			"countryId":"484",
			"preselectedState":"CHP",
			"shopAddressCountryId" : "276",
			"formError":false,
			"shopRegistrationField":{
				"state":{
					"isVisibleName":false,
					"isMandatoryName":false
				},
				"countryId":{
					"isVisibleName":true,
					"isMandatoryName":true
				}
			},
			"data":{
				"32":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"36":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"56":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"76":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"124":{
					"subdivsMandatory":true,
					"subDivisions":[
						{
							"code":"AB",
							"language":{
								"english":"Alberta",
								"native":""
							}
						},{
							"code":"BC",
							"language":{
								"english":"British Columbia",
								"native":""
							}
						},{
							"code":"MB",
							"language":{
								"english":"Manitoba",
								"native":""
							}
						},{
							"code":"NB",
							"language":{
								"english":"New Brunswick",
								"native":""
							}
						},{
							"code":"NL",
							"language":{
								"english":"Newfoundland and Labrador",
								"native":""
							}
						},{
							"code":"NT",
							"language":{
								"english":"Northwest Territories",
								"native":""
							}
						},{
							"code":"NS",
							"language":{
								"english":"Nova Scotia",
								"native":""
							}
						},{
							"code":"NU",
							"language":{
								"english":"Nunavut",
								"native":""
							}
						},{
							"code":"ON",
							"language":{
								"english":"Ontario",
								"native":""
							}
						},{
							"code":"PE",
							"language":{
								"english":"Prince Edward Island",
								"native":""
							}
						},{
							"code":"QC",
							"language":{
								"english":"Quebec",
								"native":""
							}
						},{
							"code":"SK",
							"language":{
								"english":"Saskatchewan",
								"native":""
							}
						},{
							"code":"YT",
							"language":{
								"english":"Yukon Territory",
								"native":""
							}
						}
					]
				},"203":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"152":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"196":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"208":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"276":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"233":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"724":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"250":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"356":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"372":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"380":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"428":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"440":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"442":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"348":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"470":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"484":{
					"subdivsMandatory":true,
					"subDivisions":[
						{
							"code":"AGU",
							"language":{
								"english":"Aguascalientes",
								"native":""
							}
						},{
							"code":"BCN",
							"language":{
								"english":"Baja California",
								"native":""
							}
						},{
							"code":"BCS",
							"language":{
								"english":"Baja California Sur",
								"native":""
							}
						},{
							"code":"CAM",
							"language":{
								"english":"Campeche",
								"native":""
							}
						},{
							"code":"CHP",
							"language":{
								"english":"Chiapas",
								"native":""
							}
						},{
							"code":"CHH",
							"language":{
								"english":"Chihuahua",
								"native":""
							}
						},{
							"code":"COA",
							"language":{
								"english":"Coahuila",
								"native":""
							}
						},{
							"code":"COL",
							"language":{
								"english":"Colima",
								"native":""
							}
						},{
							"code":"DUR",
							"language":{
								"english":"Durango",
								"native":""
							}
						},{
							"code":"GUA",
							"language":{
								"english":"Guanajuato",
								"native":""
							}
						},{
							"code":"GRO",
							"language":{
								"english":"Guerrero",
								"native":""
							}
						},{
							"code":"HID",
							"language":{
								"english":"Hidalgo",
								"native":""
							}
						},{
							"code":"JAL",
							"language":{
								"english":"Jalisco",
								"native":""
							}
						},{
							"code":"DF",
							"language":{
								"english":"Mexico City (Distrito Federal)",
								"native":""
							}
						},{
							"code":"MIC",
							"language":{
								"english":"Michoacán",
								"native":""
							}
						},{
							"code":"MOR",
							"language":{
								"english":"Morelos",
								"native":""
							}
						},{
							"code":"MEX",
							"language":{
								"english":"México",
								"native":""
							}
						},{
							"code":"NAY",
							"language":{
								"english":"Nayarit",
								"native":""
							}
						},{
							"code":"NLE",
							"language":{
								"english":"Nuevo León",
								"native":""
							}
						},{
							"code":"OAX",
							"language":{
								"english":"Oaxaca",
								"native":""
							}
						},{
							"code":"PUE",
							"language":{
								"english":"Puebla",
								"native":""
							}
						},{
							"code":"QUE",
							"language":{
								"english":"Querétaro",
								"native":""
							}
						},{
							"code":"ROO",
							"language":{
								"english":"Quintana Roo",
								"native":""
							}
						},{
							"code":"SLP",
							"language":{
								"english":"San Luis Potosí",
								"native":""
							}
						},{
							"code":"SIN",
							"language":{
								"english":"Sinaloa",
								"native":""
							}
						},{
							"code":"SON",
							"language":{
								"english":"Sonora",
								"native":""
							}
						},{
							"code":"TAB",
							"language":{
								"english":"Tabasco",
								"native":""
							}
						},{
							"code":"TAM",
							"language":{
								"english":"Tamaulipas",
								"native":""
							}
						},{
							"code":"TLA",
							"language":{
								"english":"Tlaxcala",
								"native":""
							}
						},{
							"code":"VER",
							"language":{
								"english":"Veracruz",
								"native":""
							}
						},{
							"code":"YUC",
							"language":{
								"english":"Yucatán",
								"native":""
							}
						},{
							"code":"ZAC",
							"language":{
								"english":"Zacatecas",
								"native":""
							}
						}
					]
				},"528":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"578":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"40":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"616":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"620":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"756":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"705":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"703":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"710":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"246":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"752":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"792":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"826":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"840":{
					"subdivsMandatory":true,
					"subDivisions":[
						{
							"code":"AL",
							"language":{
								"english":"Alabama",
								"native":""
							}
						},{
							"code":"AK",
							"language":{
								"english":"Alaska",
								"native":""
							}
						},{
							"code":"AS",
							"language":{
								"english":"American Samoa",
								"native":""
							}
						},{
							"code":"AZ",
							"language":{
								"english":"Arizona",
								"native":""
							}
						},{
							"code":"AR",
							"language":{
								"english":"Arkansas",
								"native":""
							}
						},{
							"code":"CA",
							"language":{
								"english":"California",
								"native":""
							}
						},{
							"code":"CO",
							"language":{
								"english":"Colorado",
								"native":""
							}
						},{
							"code":"CT",
							"language":{
								"english":"Connecticut",
								"native":""
							}
						},{
							"code":"DE",
							"language":{
								"english":"Delaware",
								"native":""
							}
						},{
							"code":"DC",
							"language":{
								"english":"District Of Columbia",
								"native":""
							}
						},{
							"code":"FL",
							"language":{
								"english":"Florida",
								"native":""
							}
						},{
							"code":"GA",
							"language":{
								"english":"Georgia",
								"native":""
							}
						},{
							"code":"GU",
							"language":{
								"english":"Guam",
								"native":""
							}
						},{
							"code":"HI",
							"language":{
								"english":"Hawaii",
								"native":""
							}
						},{
							"code":"ID",
							"language":{
								"english":"Idaho",
								"native":""
							}
						},{
							"code":"IL",
							"language":{
								"english":"Illinois",
								"native":""
							}
						},{
							"code":"IN",
							"language":{
								"english":"Indiana",
								"native":""
							}
						},{
							"code":"IA",
							"language":{
								"english":"Iowa",
								"native":""
							}
						},{
							"code":"KS",
							"language":{
								"english":"Kansas",
								"native":""
							}
						},{
							"code":"KY",
							"language":{
								"english":"Kentucky",
								"native":""
							}
						},{
							"code":"LA",
							"language":{
								"english":"Louisiana",
								"native":""
							}
						},{
							"code":"ME",
							"language":{
								"english":"Maine",
								"native":""
							}
						},{
							"code":"MD",
							"language":{
								"english":"Maryland",
								"native":""
							}
						},{
							"code":"MA",
							"language":{
								"english":"Massachusetts",
								"native":""
							}
						},{
							"code":"MI",
							"language":{
								"english":"Michigan",
								"native":""
							}
						},{
							"code":"MN",
							"language":{
								"english":"Minnesota",
								"native":""
							}
						},{
							"code":"MS",
							"language":{
								"english":"Mississippi",
								"native":""
							}
						},{
							"code":"MO",
							"language":{
								"english":"Missouri",
								"native":""
							}
						},{
							"code":"MT",
							"language":{
								"english":"Montana",
								"native":""
							}
						},{
							"code":"NE",
							"language":{
								"english":"Nebraska",
								"native":""
							}
						},{
							"code":"NV",
							"language":{
								"english":"Nevada",
								"native":""
							}
						},{
							"code":"NH",
							"language":{
								"english":"New Hampshire",
								"native":""
							}
						},{
							"code":"NJ",
							"language":{
								"english":"New Jersey",
								"native":""
							}
						},{
							"code":"NM",
							"language":{
								"english":"New Mexico",
								"native":""
							}
						},{
							"code":"NY",
							"language":{
								"english":"New York",
								"native":""
							}
						},{
							"code":"NC",
							"language":{
								"english":"North Carolina",
								"native":""
							}
						},{
							"code":"ND",
							"language":{
								"english":"North Dakota",
								"native":""
							}
						},{
							"code":"MP",
							"language":{
								"english":"Northern Mariana Islands",
								"native":""
							}
						},{
							"code":"OH",
							"language":{
								"english":"Ohio",
								"native":""
							}
						},{
							"code":"OK",
							"language":{
								"english":"Oklahoma",
								"native":""
							}
						},{
							"code":"OR",
							"language":{
								"english":"Oregon",
								"native":""
							}
						},{
							"code":"PA",
							"language":{
								"english":"Pennsylvania",
								"native":""
							}
						},{
							"code":"PR",
							"language":{
								"english":"Puerto Rico",
								"native":""
							}
						},{
							"code":"RI",
							"language":{
								"english":"Rhode Island",
								"native":""
							}
						},{
							"code":"SC",
							"language":{
								"english":"South Carolina",
								"native":""
							}
						},{
							"code":"SD",
							"language":{
								"english":"South Dakota",
								"native":""
							}
						},{
							"code":"TN",
							"language":{
								"english":"Tennessee",
								"native":""
							}
						},{
							"code":"TX",
							"language":{
								"english":"Texas",
								"native":""
							}
						},{
							"code":"UM",
							"language":{
								"english":"United States Minor Outlying Islands",
								"native":""
							}
						},{
							"code":"UT",
							"language":{
								"english":"Utah",
								"native":""
							}
						},{
							"code":"VT",
							"language":{
								"english":"Vermont",
								"native":""
							}
						},{
							"code":"VI",
							"language":{
								"english":"Virgin Islands, U.S.",
								"native":""
							}
						},{
							"code":"VA",
							"language":{
								"english":"Virginia",
								"native":""
							}
						},{
							"code":"WA",
							"language":{
								"english":"Washington",
								"native":""
							}
						},{
							"code":"WV",
							"language":{
								"english":"West Virginia",
								"native":""
							}
						},{
							"code":"WI",
							"language":{
								"english":"Wisconsin",
								"native":""
							}
						},{
							"code":"WY",
							"language":{
								"english":"Wyoming",
								"native":""
							}
						}
					]
				},"392":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"158":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"410":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"376":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"643":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"156":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"300":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				}
	   		}
		});

		$('#' + 'ID509CF322AC1432E110B0_StateDiv').presentationUiStateselection({
			"input":{
				"name":"State2",
				"id":"ID509CF322AC1432E110B0_State",
				"mandatoryStar":"*",
				"label":"County",
				"emptyEntry":"(Select entry)"
			},
			"countrySelectId" : "ID509CF322AC1432E110B0_CountryID",
			"cssClasses":{
				"dialogError" : "DialogError",
				"inputField" : "InputField",
				"inputLabelling" : "InputLabelling",
				"input" : "Text",
				"select" : "LongText"
			},
			"countryId":"",
			"preselectedState":"",
			"shopAddressCountryId" : "276",
			"formError":false,
			"shopRegistrationField":{
				"state":{
					"isVisibleName":false,
					"isMandatoryName":false
				},
				"countryId":{
					"isVisibleName":true,
					"isMandatoryName":true
				}
			},
			"data":{
				"32":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"36":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"56":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"76":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"124":{
					"subdivsMandatory":true,
					"subDivisions":[
						{
							"code":"AB",
							"language":{
								"english":"Alberta",
								"native":""
							}
						},{
							"code":"BC",
							"language":{
								"english":"British Columbia",
								"native":""
							}
						},{
							"code":"MB",
							"language":{
								"english":"Manitoba",
								"native":""
							}
						},{
							"code":"NB",
							"language":{
								"english":"New Brunswick",
								"native":""
							}
						},{
							"code":"NL",
							"language":{
								"english":"Newfoundland and Labrador",
								"native":""
							}
						},{
							"code":"NT",
							"language":{
								"english":"Northwest Territories",
								"native":""
							}
						},{
							"code":"NS",
							"language":{
								"english":"Nova Scotia",
								"native":""
							}
						},{
							"code":"NU",
							"language":{
								"english":"Nunavut",
								"native":""
							}
						},{
							"code":"ON",
							"language":{
								"english":"Ontario",
								"native":""
							}
						},{
							"code":"PE",
							"language":{
								"english":"Prince Edward Island",
								"native":""
							}
						},{
							"code":"QC",
							"language":{
								"english":"Quebec",
								"native":""
							}
						},{
							"code":"SK",
							"language":{
								"english":"Saskatchewan",
								"native":""
							}
						},{
							"code":"YT",
							"language":{
								"english":"Yukon Territory",
								"native":""
							}
						}
					]
				},"203":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"152":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"196":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"208":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"276":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"233":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"724":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"250":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"356":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"372":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"380":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"428":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"440":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"442":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"348":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"470":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"484":{
					"subdivsMandatory":true,
					"subDivisions":[
						{
							"code":"AGU",
							"language":{
								"english":"Aguascalientes",
								"native":""
							}
						},{
							"code":"BCN",
							"language":{
								"english":"Baja California",
								"native":""
							}
						},{
							"code":"BCS",
							"language":{
								"english":"Baja California Sur",
								"native":""
							}
						},{
							"code":"CAM",
							"language":{
								"english":"Campeche",
								"native":""
							}
						},{
							"code":"CHP",
							"language":{
								"english":"Chiapas",
								"native":""
							}
						},{
							"code":"CHH",
							"language":{
								"english":"Chihuahua",
								"native":""
							}
						},{
							"code":"COA",
							"language":{
								"english":"Coahuila",
								"native":""
							}
						},{
							"code":"COL",
							"language":{
								"english":"Colima",
								"native":""
							}
						},{
							"code":"DUR",
							"language":{
								"english":"Durango",
								"native":""
							}
						},{
							"code":"GUA",
							"language":{
								"english":"Guanajuato",
								"native":""
							}
						},{
							"code":"GRO",
							"language":{
								"english":"Guerrero",
								"native":""
							}
						},{
							"code":"HID",
							"language":{
								"english":"Hidalgo",
								"native":""
							}
						},{
							"code":"JAL",
							"language":{
								"english":"Jalisco",
								"native":""
							}
						},{
							"code":"DF",
							"language":{
								"english":"Mexico City (Distrito Federal)",
								"native":""
							}
						},{
							"code":"MIC",
							"language":{
								"english":"Michoacán",
								"native":""
							}
						},{
							"code":"MOR",
							"language":{
								"english":"Morelos",
								"native":""
							}
						},{
							"code":"MEX",
							"language":{
								"english":"México",
								"native":""
							}
						},{
							"code":"NAY",
							"language":{
								"english":"Nayarit",
								"native":""
							}
						},{
							"code":"NLE",
							"language":{
								"english":"Nuevo León",
								"native":""
							}
						},{
							"code":"OAX",
							"language":{
								"english":"Oaxaca",
								"native":""
							}
						},{
							"code":"PUE",
							"language":{
								"english":"Puebla",
								"native":""
							}
						},{
							"code":"QUE",
							"language":{
								"english":"Querétaro",
								"native":""
							}
						},{
							"code":"ROO",
							"language":{
								"english":"Quintana Roo",
								"native":""
							}
						},{
							"code":"SLP",
							"language":{
								"english":"San Luis Potosí",
								"native":""
							}
						},{
							"code":"SIN",
							"language":{
								"english":"Sinaloa",
								"native":""
							}
						},{
							"code":"SON",
							"language":{
								"english":"Sonora",
								"native":""
							}
						},{
							"code":"TAB",
							"language":{
								"english":"Tabasco",
								"native":""
							}
						},{
							"code":"TAM",
							"language":{
								"english":"Tamaulipas",
								"native":""
							}
						},{
							"code":"TLA",
							"language":{
								"english":"Tlaxcala",
								"native":""
							}
						},{
							"code":"VER",
							"language":{
								"english":"Veracruz",
								"native":""
							}
						},{
							"code":"YUC",
							"language":{
								"english":"Yucatán",
								"native":""
							}
						},{
							"code":"ZAC",
							"language":{
								"english":"Zacatecas",
								"native":""
							}
						}
					]
				},"528":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"578":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"40":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"616":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"620":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"756":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"705":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"703":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"710":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"246":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"752":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"792":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"826":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"840":{
					"subdivsMandatory":true,
					"subDivisions":[
						{
							"code":"AL",
							"language":{
								"english":"Alabama",
								"native":""
							}
						},{
							"code":"AK",
							"language":{
								"english":"Alaska",
								"native":""
							}
						},{
							"code":"AS",
							"language":{
								"english":"American Samoa",
								"native":""
							}
						},{
							"code":"AZ",
							"language":{
								"english":"Arizona",
								"native":""
							}
						},{
							"code":"AR",
							"language":{
								"english":"Arkansas",
								"native":""
							}
						},{
							"code":"CA",
							"language":{
								"english":"California",
								"native":""
							}
						},{
							"code":"CO",
							"language":{
								"english":"Colorado",
								"native":""
							}
						},{
							"code":"CT",
							"language":{
								"english":"Connecticut",
								"native":""
							}
						},{
							"code":"DE",
							"language":{
								"english":"Delaware",
								"native":""
							}
						},{
							"code":"DC",
							"language":{
								"english":"District Of Columbia",
								"native":""
							}
						},{
							"code":"FL",
							"language":{
								"english":"Florida",
								"native":""
							}
						},{
							"code":"GA",
							"language":{
								"english":"Georgia",
								"native":""
							}
						},{
							"code":"GU",
							"language":{
								"english":"Guam",
								"native":""
							}
						},{
							"code":"HI",
							"language":{
								"english":"Hawaii",
								"native":""
							}
						},{
							"code":"ID",
							"language":{
								"english":"Idaho",
								"native":""
							}
						},{
							"code":"IL",
							"language":{
								"english":"Illinois",
								"native":""
							}
						},{
							"code":"IN",
							"language":{
								"english":"Indiana",
								"native":""
							}
						},{
							"code":"IA",
							"language":{
								"english":"Iowa",
								"native":""
							}
						},{
							"code":"KS",
							"language":{
								"english":"Kansas",
								"native":""
							}
						},{
							"code":"KY",
							"language":{
								"english":"Kentucky",
								"native":""
							}
						},{
							"code":"LA",
							"language":{
								"english":"Louisiana",
								"native":""
							}
						},{
							"code":"ME",
							"language":{
								"english":"Maine",
								"native":""
							}
						},{
							"code":"MD",
							"language":{
								"english":"Maryland",
								"native":""
							}
						},{
							"code":"MA",
							"language":{
								"english":"Massachusetts",
								"native":""
							}
						},{
							"code":"MI",
							"language":{
								"english":"Michigan",
								"native":""
							}
						},{
							"code":"MN",
							"language":{
								"english":"Minnesota",
								"native":""
							}
						},{
							"code":"MS",
							"language":{
								"english":"Mississippi",
								"native":""
							}
						},{
							"code":"MO",
							"language":{
								"english":"Missouri",
								"native":""
							}
						},{
							"code":"MT",
							"language":{
								"english":"Montana",
								"native":""
							}
						},{
							"code":"NE",
							"language":{
								"english":"Nebraska",
								"native":""
							}
						},{
							"code":"NV",
							"language":{
								"english":"Nevada",
								"native":""
							}
						},{
							"code":"NH",
							"language":{
								"english":"New Hampshire",
								"native":""
							}
						},{
							"code":"NJ",
							"language":{
								"english":"New Jersey",
								"native":""
							}
						},{
							"code":"NM",
							"language":{
								"english":"New Mexico",
								"native":""
							}
						},{
							"code":"NY",
							"language":{
								"english":"New York",
								"native":""
							}
						},{
							"code":"NC",
							"language":{
								"english":"North Carolina",
								"native":""
							}
						},{
							"code":"ND",
							"language":{
								"english":"North Dakota",
								"native":""
							}
						},{
							"code":"MP",
							"language":{
								"english":"Northern Mariana Islands",
								"native":""
							}
						},{
							"code":"OH",
							"language":{
								"english":"Ohio",
								"native":""
							}
						},{
							"code":"OK",
							"language":{
								"english":"Oklahoma",
								"native":""
							}
						},{
							"code":"OR",
							"language":{
								"english":"Oregon",
								"native":""
							}
						},{
							"code":"PA",
							"language":{
								"english":"Pennsylvania",
								"native":""
							}
						},{
							"code":"PR",
							"language":{
								"english":"Puerto Rico",
								"native":""
							}
						},{
							"code":"RI",
							"language":{
								"english":"Rhode Island",
								"native":""
							}
						},{
							"code":"SC",
							"language":{
								"english":"South Carolina",
								"native":""
							}
						},{
							"code":"SD",
							"language":{
								"english":"South Dakota",
								"native":""
							}
						},{
							"code":"TN",
							"language":{
								"english":"Tennessee",
								"native":""
							}
						},{
							"code":"TX",
							"language":{
								"english":"Texas",
								"native":""
							}
						},{
							"code":"UM",
							"language":{
								"english":"United States Minor Outlying Islands",
								"native":""
							}
						},{
							"code":"UT",
							"language":{
								"english":"Utah",
								"native":""
							}
						},{
							"code":"VT",
							"language":{
								"english":"Vermont",
								"native":""
							}
						},{
							"code":"VI",
							"language":{
								"english":"Virgin Islands, U.S.",
								"native":""
							}
						},{
							"code":"VA",
							"language":{
								"english":"Virginia",
								"native":""
							}
						},{
							"code":"WA",
							"language":{
								"english":"Washington",
								"native":""
							}
						},{
							"code":"WV",
							"language":{
								"english":"West Virginia",
								"native":""
							}
						},{
							"code":"WI",
							"language":{
								"english":"Wisconsin",
								"native":""
							}
						},{
							"code":"WY",
							"language":{
								"english":"Wyoming",
								"native":""
							}
						}
					]
				},"392":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"158":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"410":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"376":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"643":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"156":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				},"300":{
					"subdivsMandatory":false,
					"subDivisions":[

					]
				}
	   		}
		});
	
		// Check created form data.
		QUnit.equal(
			$form.serialize(),
			'CountryID1=484&State1=CHP&CountryID2=&State2=',
			'*form* data after creation:'
		);
	
		// Check if form elements have the correct type and *uiValidate* works.
		QUnit.equal(
			$form.find('[name="State1"]').is('select'),
			true,
			'$form.find(\'[name="State1"]\').is(\'select\')'
		);
		
		QUnit.equal(
			$($form.find('[name="State1"]')).uiValidate('option', 'required'),
			true,
			'$($form.find(\'[name="State1"]\')).uiValidate(\'option\', \'required\')'
		);
		
		QUnit.equal(
			$form.find('[name="State2"]').is('input'),
			true,
			'$form.find(\'[name="State2"]\').is(\'input\')'
		);
		
		QUnit.equal(
			$form.find('[name="State2"]').attr('type'),
			'hidden',
			'$form.find(\'[name="State2"]\').attr(\'type\'):'
		);
		
		QUnit.equal(
			$form.find('[name="State2"]').data('uiUiValidate'),
			undefined,
			'$form.find(\'[name="State1"]\').data(\'uiUiValidate\')'
		);
	
		// Select country w/o mandatory stateselection.
		var $countries = $form.find('select[name="CountryID1"] option');
		$countries.filter(':selected').attr('selected', false);
		$countries.filter('[value=752]')
			.attr('selected', true)
			.trigger('change');

		QUnit.equal(
			$form.serialize(),
			"CountryID1=752&State1=&CountryID2=&State2=",
			'*form* data after selecting a country w/o mandatory stateselection:'
		);
	
			// Check if form elements have the correct type and *uiValidate* works.
		QUnit.equal(
			$form.find('[name="State1"]').is('input'),
			true,
			'$form.find(\'[name="State1"]\').is(\'input\')'
		);
		
		QUnit.equal(
			$form.find('[name="State1"]').attr('type'),
			'hidden',
			'$form.find(\'[name="State1"]\').attr(\'type\'):'
		);
		
		QUnit.equal(
			$($form.find('[name="State1"]')).data('uiUiValidate'),
			undefined,
			'$form.find(\'[name="State1"]\').data(\'uiUiValidate\'):'
		);
		
		QUnit.equal(
			$form.find('[name="State2"]').is('input'),
			true,
			'$form.find(\'[name="State2"]\').is(\'input\'):'
		);
		
		QUnit.equal(
			$form.find('[name="State2"]').attr('type'),
			'hidden',
			'$form.find(\'[name="State2"]\').attr(\'type\'):'
		);
		
		QUnit.equal(
			$form.find('[name="State2"]').data('uiUiValidate'),
			undefined,
			'$form.find(\'[name="State2"]\').data(\'uiUiValidate\'):'
		);
	
		// Destroy.
		$('#' + 'ID509CF322AC1432E110B9_StateDiv').presentationUiStateselection('destroy');
		$('#' + 'ID509CF322AC1432E110B0_StateDiv').presentationUiStateselection('destroy');
	
		QUnit.equal(
			$('#' + 'ID509CF322AC1432E110B9_StateDiv').data('de_epagesPresentationUiStateselection') === undefined,
				true,
				'*destroy* removed instance1 from respective data attribute:'
		);
		
		QUnit.equal(
			$('#' + 'ID509CF322AC1432E110B0_StateDiv').data('de_epagesPresentationUiStateselection') === undefined,
				true,
				'*destroy* removed instance2 from respective data attribute:'
		);
	
		QUnit.start();
	
	});
});