define(['testsuite/qunit', 'jquery', 'de_epages/shop/ui/userblogwidget', 'testsuite/sinon', 'testsuite/sinon/server', 'testsuite/sinon/ie', '$ready!'], function (QUnit, $, de_epages, sinon) {

	QUnit.module("de_epages/shop/ui/userblogwidget");

	QUnit.asyncTest("de_epages/shop/ui/userblogwidget", function() {

		var xmlResponse = $('#rssData').html(),

			sandbox = sinon.sandbox.create(),

			server = sandbox.useFakeServer();

		server.respondWith([200, { "Content-Type": "application/rss+xml" }, xmlResponse]);

		$('.ep-UserBlogWidget').shopUiUserBlogWidget({'url':  'http://blog.epages.com/de/feed/'});

		server.respond();

		QUnit.equal(
			$('.ep-shopUiUserBlogWidget-itemContent').length,
			3,
			'check entry count'
		);

		var entryLength = de_epages('.ep-UserBlogWidget').shopUiUserBlogWidget('option','entryLength');

		$('.ep-shopUiUserBlogWidget-itemTitle').each(function(){

			QUnit.ok( this.innerHTML.length <= entryLength, "check entryLength" );

		});

		QUnit.equal(
			$('.ep-uiTooltip').length,
			3,
			'check tooltip count'
		);

		QUnit.start();

	});
});