define(['testsuite/qunit', 'jquery', 'de_epages/shop/ui/usercommunitywidget', 'testsuite/sinon', 'testsuite/sinon/server', 'testsuite/sinon/ie', '$ready!'], function (QUnit, $, de_epages, sinon) {

	QUnit.module("de_epages/shop/ui/usercommunitywidget");

	QUnit.asyncTest("de_epages/shop/ui/usercommunitywidget", function() {

		var xmlResponse = $('#rssData').html(),

			sandbox = sinon.sandbox.create(),

			server = sandbox.useFakeServer();

		server.respondWith([200, { "Content-Type": "application/rss+xml" }, xmlResponse]);

		$('.ep-UserBlogWidget').shopUiUserCommunityWidget({'url':  'http://blog.epages.com/de/feed/'});

		server.respond();

		QUnit.equal($('.ep-shopUiUserCommunityWidget-item').length, 3,'check entry count');

		var entryLength = de_epages('.ep-UserBlogWidget').shopUiUserCommunityWidget('option','entryLength');

		$('.ep-shopUiUserCommunityWidget-itemTitle').each(function(){

			QUnit.ok( this.innerHTML.length <= entryLength, "check entryLength" );

		});

		QUnit.start();
	});
});